## bowtie2 2.2.6

=== Makefile ===
#
# Copyright 2011, Ben Langmead <langmea@cs.jhu.edu>
#
# This file is part of Bowtie 2.
#
# Bowtie 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Bowtie 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Bowtie 2.  If not, see <http://www.gnu.org/licenses/>.
#

#
# Makefile for bowtie, bowtie2-build, bowtie2-inspect
#

prefix = /usr/local
bindir = $(prefix)/bin

INC =
GCC_PREFIX = $(shell dirname `which gcc`)
GCC_SUFFIX =
CC ?= $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
CPP ?= $(GCC_PREFIX)/g++$(GCC_SUFFIX)
CXX ?= $(CPP)
HEADERS = $(wildcard *.h)
BOWTIE_MM = 1
BOWTIE_SHARED_MEM = 0

# Detect Cygwin or MinGW
WINDOWS = 0
MINGW = 0
ifneq (,$(findstring MINGW,$(shell uname)))
	WINDOWS = 1
	MINGW = 1
	# POSIX memory-mapped files not currently supported on Windows
	BOWTIE_MM = 0
	BOWTIE_SHARED_MEM = 0
endif

MACOS = 0
ifneq (,$(findstring Darwin,$(shell uname)))
	MACOS = 1
	ifneq (,$(findstring 13,$(shell uname -r)))
		CPP = clang++
		CC = clang
		override EXTRA_FLAGS += -stdlib=libstdc++
	endif
endif

POPCNT_CAPABILITY ?= 1
ifeq (1, $(POPCNT_CAPABILITY))
    override EXTRA_FLAGS += -DPOPCNT_CAPABILITY
    INC += -I third_party
endif

MM_DEF = 

ifeq (1,$(BOWTIE_MM))
	MM_DEF = -DBOWTIE_MM
endif

SHMEM_DEF = 

ifeq (1,$(BOWTIE_SHARED_MEM))
	SHMEM_DEF = -DBOWTIE_SHARED_MEM
endif

PTHREAD_PKG =
PTHREAD_LIB = 

ifeq (1,$(MINGW))
	PTHREAD_LIB = 
else
	PTHREAD_LIB = -lpthread
endif

ifeq (1,$(NO_SPINLOCK))
	override EXTRA_FLAGS += -DNO_SPIN_LOCK
endif

ifeq (1,$(WITH_TBB))
	LIBS = $(PTHREAD_LIB) -ltbb -ltbbmalloc_proxy
	override EXTRA_FLAGS += -DWITH_TBB
else
	LIBS = $(PTHREAD_LIB)
endif
SEARCH_LIBS = 
BUILD_LIBS = 
INSPECT_LIBS =

ifeq (1,$(MINGW))
	BUILD_LIBS = 
	INSPECT_LIBS = 
endif

ifeq (1,$(WITH_THREAD_PROFILING))
	override EXTRA_FLAGS += -DPER_THREAD_TIMING=1
endif

SHARED_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
              edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
              reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
			  random_source.cpp
ifneq (1,$(WITH_TBB))
	SHARED_CPPS += tinythread.cpp
endif

SEARCH_CPPS = qual.cpp pat.cpp sam.cpp \
              read_qseq.cpp aligner_seed_policy.cpp \
              aligner_seed.cpp \
			  aligner_seed2.cpp \
			  aligner_sw.cpp \
			  aligner_sw_driver.cpp aligner_cache.cpp \
			  aligner_result.cpp ref_coord.cpp mask.cpp \
			  pe.cpp aln_sink.cpp dp_framer.cpp \
			  scoring.cpp presets.cpp unique.cpp \
			  simple_func.cpp \
			  random_util.cpp \
			  aligner_bt.cpp sse_util.cpp \
			  aligner_swsse.cpp outq.cpp \
			  aligner_swsse_loc_i16.cpp \
			  aligner_swsse_ee_i16.cpp \
			  aligner_swsse_loc_u8.cpp \
			  aligner_swsse_ee_u8.cpp \
			  aligner_driver.cpp
SEARCH_CPPS_MAIN = $(SEARCH_CPPS) bowtie_main.cpp

DP_CPPS = qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
          simple_func.cpp sse_util.cpp aligner_bt.cpp aligner_swsse.cpp \
		  aligner_swsse_loc_i16.cpp aligner_swsse_ee_i16.cpp \
		  aligner_swsse_loc_u8.cpp aligner_swsse_ee_u8.cpp scoring.cpp

BUILD_CPPS = diff_sample.cpp
BUILD_CPPS_MAIN = $(BUILD_CPPS) bowtie_build_main.cpp

SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
VERSION = $(shell cat VERSION)

BITS=32
ifeq (x86_64,$(shell uname -m))
	BITS=64
endif
ifeq (amd64,$(shell uname -m))
	BITS=64
endif
# msys will always be 32 bit so look at the cpu arch instead.
ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
	ifeq (1,$(MINGW))
		BITS=64
	endif
endif
ifeq (32,$(BITS))
  $(error bowtie2 compilation requires a 64-bit platform )
endif

SSE_FLAG=-msse2 

DEBUG_FLAGS    = -O0 -g3 -m64 $(SSE_FLAG)
DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
RELEASE_FLAGS  = -O3 -m64 $(SSE_FLAG) -funroll-loops -g3
RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS)\""
NOASSERT_FLAGS = -DNDEBUG
FILE_FLAGS     = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE

BOWTIE2_BIN_LIST =     bowtie2-build-s \
                       bowtie2-build-l \
                       bowtie2-align-s \
                       bowtie2-align-l \
                       bowtie2-inspect-s \
                       bowtie2-inspect-l
BOWTIE2_BIN_LIST_AUX = bowtie2-build-s-debug \
                       bowtie2-build-l-debug \
                       bowtie2-align-s-debug \
                       bowtie2-align-l-debug \
                       bowtie2-inspect-s-debug \
                       bowtie2-inspect-l-debug

GENERAL_LIST = $(wildcard scripts/*.sh) \
               $(wildcard scripts/*.pl) \
               doc/manual.html \
               doc/README \
               doc/style.css \
			   $(wildcard example/index/*.bt2) \
			   $(wildcard example/reads/*.fq) \
			   $(wildcard example/reads/*.pl) \
			   example/reference/lambda_virus.fa \
               $(PTHREAD_PKG) \
			   bowtie2 \
			   bowtie2-build \
			   bowtie2-inspect \
               AUTHORS \
               LICENSE \
               NEWS \
               MANUAL \
               MANUAL.markdown \
               TUTORIAL \
               VERSION

ifeq (1,$(WINDOWS))
	BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat 
	EXTRA_FLAGS += -static-libgcc -static-libstdc++
endif

# This is helpful on Windows under MinGW/MSYS, where Make might go for
# the Windows FIND tool instead.
FIND=$(shell which find)

SRC_PKG_LIST = $(wildcard *.h) \
               $(wildcard *.hh) \
               $(wildcard *.c) \
               $(wildcard *.cpp) \
               $(wildcard third_party/*) \
               doc/strip_markdown.pl \
               Makefile \
               $(GENERAL_LIST)

ifeq (1,$(WINDOWS))
	BIN_PKG_LIST = $(GENERAL_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat 
else
	BIN_PKG_LIST = $(GENERAL_LIST)
endif

.PHONY: all allall both both-debug

all: $(BOWTIE2_BIN_LIST)

allall: $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)

both: bowtie2-align-s bowtie2-build-s bowtie2-align-l bowtie2-build-l

both-debug: bowtie2-align-s-debug bowtie2-build-s-debug bowtie2-align-l-debug bowtie2-build-l-debug

DEFS=-fno-strict-aliasing \
     -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
     -DBUILD_HOST="\"`hostname`\"" \
     -DBUILD_TIME="\"`date`\"" \
     -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
     $(FILE_FLAGS) \
     $(PREF_DEF) \
     $(MM_DEF) \
     $(SHMEM_DEF)

#
# bowtie2-build targets
#

bowtie2-build-s: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie2-build-l: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie2-build-s-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie2-build-l-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

#
# bowtie2-align targets
#

bowtie2-align-s: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie2-align-l: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie2-align-s-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie2-align-l-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

#
# bowtie2-inspect targets
#

bowtie2-inspect-s: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LIBS) $(INSPECT_LIBS)

bowtie2-inspect-l: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LIBS) $(INSPECT_LIBS)

bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LIBS) $(INSPECT_LIBS)

bowtie2-inspect-l-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LIBS) $(INSPECT_LIBS)

#
# bowtie2-dp targets
#

bowtie2-dp: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(EXTRA_FLAGS) $(NOASSERT_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(DP_CPPS) $(SHARED_CPPS) \
		$(LIBS) $(SEARCH_LIBS)

bowtie2-dp-debug: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(DP_CPPS) $(SHARED_CPPS) \
		$(LIBS) $(SEARCH_LIBS)

bowtie2.bat:
	echo "@echo off" > bowtie2.bat
	echo "perl %~dp0/bowtie2 %*" >> bowtie2.bat

bowtie2-build.bat:
	echo "@echo off" > bowtie2-build.bat
	echo "python %~dp0/bowtie2-build %*" >> bowtie2-build.bat

bowtie2-inspect.bat:
	echo "@echo off" > bowtie2-inspect.bat
	echo "python %~dp0/bowtie2-inspect %*" >> bowtie2-inspect.bat

.PHONY: bowtie2-src
bowtie2-src: $(SRC_PKG_LIST)
	chmod a+x scripts/*.sh scripts/*.pl
	mkdir .src.tmp
	mkdir .src.tmp/bowtie2-$(VERSION)
	zip tmp.zip $(SRC_PKG_LIST)
	mv tmp.zip .src.tmp/bowtie2-$(VERSION)
	cd .src.tmp/bowtie2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .src.tmp ; zip -r bowtie2-$(VERSION)-source.zip bowtie2-$(VERSION)
	cp .src.tmp/bowtie2-$(VERSION)-source.zip .
	rm -rf .src.tmp

.PHONY: bowtie2-bin
bowtie2-bin: $(BIN_PKG_LIST) $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) 
	chmod a+x scripts/*.sh scripts/*.pl
	rm -rf .bin.tmp
	mkdir .bin.tmp
	mkdir .bin.tmp/bowtie2-$(VERSION)
	if [ -f bowtie2-align-s.exe ] ; then \
		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)) ; \
	else \
		zip tmp.zip $(BIN_PKG_LIST) $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) ; \
	fi
	mv tmp.zip .bin.tmp/bowtie2-$(VERSION)
	cd .bin.tmp/bowtie2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .bin.tmp ; zip -r bowtie2-$(VERSION).zip bowtie2-$(VERSION)
	cp .bin.tmp/bowtie2-$(VERSION).zip .
	rm -rf .bin.tmp

=== debian/changelog ===
bowtie2 (2.2.6-2) unstable; urgency=medium

  [ Charles Plessy ]
  * d/rules: quote variables contents passed to Makefile, closes: #809076.

 -- Andreas Tille <tille@debian.org>  Mon, 28 Dec 2015 08:23:51 +0100

bowtie2 (2.2.6-1) unstable; urgency=medium

  * Imported Upstream version 2.2.6
  * d/rules: WITH_TBB=1

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 28 Aug 2015 09:31:45 +0200

=== debian/control ===
Source: bowtie2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
           Andreas Tille <tille@debian.org>,
           Carlos Borroto <carlos.borroto@gmail.com>
Section: science
Testsuite: autopkgtest
Priority: optional
Build-Depends: debhelper (>= 9.0), help2man, libtbb-dev, python
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
Vcs-Git: git://anonscm.debian.org/debian-med/bowtie2.git
Homepage: http://bowtie-bio.sourceforge.net/bowtie2

Package: bowtie2
Architecture: amd64 kfreebsd-amd64
Depends: python, ${misc:Depends}, ${shlibs:Depends}
Suggests: bowtie2-examples
Description: ultrafast memory-efficient short read aligner
 is an ultrafast and memory-efficient tool for aligning sequencing reads
 to long reference sequences. It is particularly good at aligning reads
 of about 50 up to 100s or 1,000s of characters, and particularly good
 at aligning to relatively long (e.g. mammalian) genomes.
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes

Package: bowtie2-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: bowtie2
Enhances: bowtie2
Description: Examples for bowtie2
 An ultrafast and memory-efficient tool for aligning sequencing reads
 to long reference sequences. It is particularly good at aligning reads
 of about 50 up to 100s or 1,000s of characters, and particularly good
 at aligning to relatively long (e.g. mammalian) genomes.
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes
 .
 This package provides some example data to work with bowtie2.

=== debian/rules ===
#!/usr/bin/make -f

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
EXTRA_FLAGS := $(LDFLAGS)

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
EXTRA_OPTIONS =
ifeq ($(DEB_HOST_ARCH),amd64)
        EXTRA_OPTIONS = WITH_TBB=1
endif
export EXTRA_OPTIONS


%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build -- EXTRA_FLAGS="$(EXTRA_FLAGS)" CPPFLAGS="$(CPPFLAGS)" $(EXTRA_OPTIONS)

override_dh_installman:
	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
	debian/help2man-wrapper $(pkg) "wrapper for $(pkg)-align-*"
	debian/help2man-wrapper $(pkg)-build "wrapper for $(pkg)-build-*"
	debian/help2man-wrapper $(pkg)-build-l "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-build-s "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-inspect "wrapper for $(pkg)-inspect-* index"
	debian/help2man-wrapper $(pkg)-inspect-l "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-inspect-s "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-align-l "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
	debian/help2man-wrapper $(pkg)-align-s "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
	rm -f $(CURDIR)/debian/$(pkg)/usr/bin/bowtie2-buildc

override_dh_installchangelogs:
	dh_installchangelogs NEWS

get-orig-source:
	mkdir -p ../tarballs
	uscan --verbose --force-download --repack --compress xz --destdir ../tarballs

=== debian/tests/control ===
Tests: indexing-ref-genome

Tests: binary-run

=== debian/watch ===
version=3

opts=filenamemangle=s@.*/(bowtie2-[\d.]+)-source(\.zip)$@$1@ \
http://sf.net/bowtie-bio/bowtie2-([\d.]+)-source\.zip

## bowtie2 2.2.9

=== debian/changelog ===
bowtie2 (2.2.9-4) unstable; urgency=medium

  * Team upload.
  * Make build reproducible by adding compiler flags
    setting -fdebug-prefix-map.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 25 Aug 2016 12:47:33 +0000

bowtie2 (2.2.9-3) unstable; urgency=medium

  * Team upload.
  * Fix building with GCC 6.
    Closes: #831157.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 16 Jul 2016 03:22:51 +0000

bowtie2 (2.2.9-2) unstable; urgency=medium

  * Team upload.
  * Make build reproducible.
    - Remove embedding of build hostname, time and compiler.
    - Fix help2man wrapper heredoc.
    - Sort wildcard expansions in Makefile.
    - Pin down language settings.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sat, 21 May 2016 17:18:25 +0000

bowtie2 (2.2.9-1) unstable; urgency=medium

  * Imported Upstream version 2.2.9
  * Bump Standards-Version
  * Revert the commit with applied patch
  * Update hardening.patch
  * Cleanup d/rules, remove CPPFLAGS as they are imported anyway

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 28 Apr 2016 09:26:48 +0200

bowtie2 (2.2.8-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version repackaged as xz
  * cme fix dpkg-control

  [ Alexandre Mestiashvili ]
  * Imported Upstream version 2.2.8
  * d/rules: export DEB_BUILD_MAINT_OPTIONS = hardening=+all
  * d/copyright: Merge Files: stanzas and update years

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Sat, 12 Mar 2016 15:57:34 +0100

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,20 @@
 Section: science
 Testsuite: autopkgtest
 Priority: optional
-Build-Depends: debhelper (>= 9.0), help2man, libtbb-dev, python
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9.0),
+               help2man,
+               libtbb-dev,
+               python
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
-Vcs-Git: git://anonscm.debian.org/debian-med/bowtie2.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
 
 Package: bowtie2
 Architecture: amd64 kfreebsd-amd64
-Depends: python, ${misc:Depends}, ${shlibs:Depends}
+Depends: python,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Suggests: bowtie2-examples
 Description: ultrafast memory-efficient short read aligner
  is an ultrafast and memory-efficient tool for aligning sequencing reads

=== debian/rules ===
--- 
+++ 
@@ -2,9 +2,10 @@
 
 pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
 
-CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
-EXTRA_FLAGS := $(LDFLAGS)
+export LANG=C
+export LC_ALL=C.UTF-8
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 EXTRA_OPTIONS =
@@ -13,12 +14,11 @@
 endif
 export EXTRA_OPTIONS
 
-
 %:
 	dh $@ --parallel
 
 override_dh_auto_build:
-	dh_auto_build -- EXTRA_FLAGS="$(EXTRA_FLAGS)" CPPFLAGS="$(CPPFLAGS)" $(EXTRA_OPTIONS)
+	dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)
 
 override_dh_installman:
 	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/

=== debian/watch ===
version=3

opts=filenamemangle=s@.*/(bowtie2-[\d.]+)-source(\.zip)$@$1@,repack,compression=xz \
http://sf.net/bowtie-bio/bowtie2-([\d.]+)-source\.zip

## bowtie2 2.3.0

=== Makefile ===
--- 
+++ 
@@ -43,6 +43,7 @@
 	# POSIX memory-mapped files not currently supported on Windows
 	BOWTIE_MM = 0
 	BOWTIE_SHARED_MEM = 0
+	override EXTRA_FLAGS += -ansi
 endif
 
 MACOS = 0
@@ -61,55 +62,73 @@
     INC += -I third_party
 endif
 
-MM_DEF = 
+MM_DEF =
 
 ifeq (1,$(BOWTIE_MM))
 	MM_DEF = -DBOWTIE_MM
 endif
 
-SHMEM_DEF = 
+SHMEM_DEF =
 
 ifeq (1,$(BOWTIE_SHARED_MEM))
 	SHMEM_DEF = -DBOWTIE_SHARED_MEM
 endif
 
 PTHREAD_PKG =
-PTHREAD_LIB = 
+PTHREAD_LIB =
+
+#if we're not using TBB, then we can't use queuing locks
+ifeq (1,$(NO_TBB))
+	NO_QUEUELOCK=1
+endif
 
 ifeq (1,$(MINGW))
-	PTHREAD_LIB = 
+	PTHREAD_LIB =
 else
 	PTHREAD_LIB = -lpthread
 endif
 
 ifeq (1,$(NO_SPINLOCK))
-	override EXTRA_FLAGS += -DNO_SPIN_LOCK
-endif
-
-ifeq (1,$(WITH_TBB))
+	override EXTRA_FLAGS += -DNO_SPINLOCK
+endif
+
+#default is to use Intel TBB
+ifneq (1,$(NO_TBB))
 	LIBS = $(PTHREAD_LIB) -ltbb -ltbbmalloc_proxy
 	override EXTRA_FLAGS += -DWITH_TBB
 else
 	LIBS = $(PTHREAD_LIB)
 endif
-SEARCH_LIBS = 
-BUILD_LIBS = 
+SEARCH_LIBS =
+BUILD_LIBS =
 INSPECT_LIBS =
 
 ifeq (1,$(MINGW))
-	BUILD_LIBS = 
-	INSPECT_LIBS = 
+	BUILD_LIBS =
+	INSPECT_LIBS =
 endif
 
 ifeq (1,$(WITH_THREAD_PROFILING))
 	override EXTRA_FLAGS += -DPER_THREAD_TIMING=1
 endif
+
+ifeq (1,$(WITH_AFFINITY))
+	override EXTRA_FLAGS += -DWITH_AFFINITY=1
+endif
+
+#default is to use Intel TBB's queuing lock for better thread scaling performance
+ifneq (1,$(NO_QUEUELOCK))
+	override EXTRA_FLAGS += -DNO_SPINLOCK
+	override EXTRA_FLAGS += -DWITH_QUEUELOCK=1
+endif
+
 
 SHARED_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
               edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
               reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
 			  random_source.cpp
-ifneq (1,$(WITH_TBB))
+
+ifeq (1,$(NO_TBB))
 	SHARED_CPPS += tinythread.cpp
 endif
 
@@ -131,6 +150,7 @@
 			  aligner_swsse_loc_u8.cpp \
 			  aligner_swsse_ee_u8.cpp \
 			  aligner_driver.cpp
+
 SEARCH_CPPS_MAIN = $(SEARCH_CPPS) bowtie_main.cpp
 
 DP_CPPS = qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
@@ -161,7 +181,7 @@
   $(error bowtie2 compilation requires a 64-bit platform )
 endif
 
-SSE_FLAG=-msse2 
+SSE_FLAG=-msse2
 
 DEBUG_FLAGS    = -O0 -g3 -m64 $(SSE_FLAG)
 DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
@@ -205,8 +225,12 @@
                VERSION
 
 ifeq (1,$(WINDOWS))
-	BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat 
-	EXTRA_FLAGS += -static-libgcc -static-libstdc++
+	BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
+    ifneq (1,$(NO_TBB))
+	    override EXTRA_FLAGS += -static-libgcc -static-libstdc++
+	else
+	    override EXTRA_FLAGS += -static -static-libgcc -static-libstdc++
+	endif
 endif
 
 # This is helpful on Windows under MinGW/MSYS, where Make might go for
@@ -223,7 +247,7 @@
                $(GENERAL_LIST)
 
 ifeq (1,$(WINDOWS))
-	BIN_PKG_LIST = $(GENERAL_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat 
+	BIN_PKG_LIST = $(GENERAL_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
 else
 	BIN_PKG_LIST = $(GENERAL_LIST)
 endif
@@ -344,7 +368,7 @@
 		$(SHARED_CPPS) \
 		$(LIBS) $(INSPECT_LIBS)
 
-bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
+bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
 		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
@@ -408,20 +432,5 @@
 	cp .src.tmp/bowtie2-$(VERSION)-source.zip .
 	rm -rf .src.tmp
 
-.PHONY: bowtie2-bin
-bowtie2-bin: $(BIN_PKG_LIST) $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) 
-	chmod a+x scripts/*.sh scripts/*.pl
-	rm -rf .bin.tmp
-	mkdir .bin.tmp
-	mkdir .bin.tmp/bowtie2-$(VERSION)
-	if [ -f bowtie2-align-s.exe ] ; then \
-		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)) ; \
-	else \
-		zip tmp.zip $(BIN_PKG_LIST) $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) ; \
-	fi
-	mv tmp.zip .bin.tmp/bowtie2-$(VERSION)
-	cd .bin.tmp/bowtie2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .bin.tmp ; zip -r bowtie2-$(VERSION).zip bowtie2-$(VERSION)
-	cp .bin.tmp/bowtie2-$(VERSION).zip .
-	rm -rf .bin.tmp
-
+.PHONY: bowtie2-pkg
+bowtie2-pkg: $(BIN_PKG_LIST) $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)

=== debian/changelog ===
bowtie2 (2.3.0-2) unstable; urgency=medium

  * Team upload.

  [ Sascha Steinbiss ]
  * Skip tests involving simulated reads to avoid use of non-free build-dep
    libmath-random-perl again.
    Closes: #852546
  * Add libclone-perl build dependency.

  [ Alexandre Mestiashvili ]
  * Add patch suppressing -Wmisleading-indentation warnings.

  [ Steffen Moeller ]
  * Adjust EDAM annotations.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 25 Jan 2017 16:27:13 +0100

bowtie2 (2.3.0-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
  * Code available on Github
  * debhelper 10
  * Remove Carlos Borroto from Uploaders
  * Remove code from test suite that is requiring non-free package
    libmath-random-perl
  * New Build-Depends to run build time test: liblocal-lib-perl

  [ Sascha Steinbiss ]
  * Even more new Build-Depends: libmath-random-perl, libtest-deep-perl
  * Disable rebuilding during tests

 -- Sascha Steinbiss <satta@debian.org>  Sat, 14 Jan 2017 07:50:51 +0000

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,17 @@
 Source: bowtie2
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
-           Andreas Tille <tille@debian.org>,
-           Carlos Borroto <carlos.borroto@gmail.com>
+           Andreas Tille <tille@debian.org>
 Section: science
 Testsuite: autopkgtest
 Priority: optional
-Build-Depends: debhelper (>= 9.0),
+Build-Depends: debhelper (>= 10),
                help2man,
                libtbb-dev,
-               python
+               python,
+               liblocal-lib-perl,
+               libtest-deep-perl,
+               libclone-perl
 Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie2.git

=== debian/rules ===
--- 
+++ 
@@ -9,16 +9,32 @@
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 EXTRA_OPTIONS =
-ifeq ($(DEB_HOST_ARCH),amd64)
-        EXTRA_OPTIONS = WITH_TBB=1
+ifneq ($(DEB_HOST_ARCH),amd64)
+        EXTRA_OPTIONS = NO_TBB=1
 endif
 export EXTRA_OPTIONS
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_build:
 	dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)
+
+override_dh_auto_test:
+	$(MAKE) EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) \
+	  bowtie2-build-s-debug \
+	  bowtie2-build-l-debug \
+	  bowtie2-align-s-debug \
+	  bowtie2-align-l-debug \
+	  bowtie2-inspect-s-debug \
+	  bowtie2-inspect-l-debug
+	make -j1 test
+
+override_dh_auto_install:
+	dh_auto_install
+
+override_dh_install:
+	dh_install -X.gitignore
 
 override_dh_installman:
 	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
@@ -35,7 +51,3 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs NEWS
-
-get-orig-source:
-	mkdir -p ../tarballs
-	uscan --verbose --force-download --repack --compress xz --destdir ../tarballs

## bowtie2 2.3.2

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,7 @@
 bindir = $(prefix)/bin
 
 INC =
+LIBS = -lz
 GCC_PREFIX = $(shell dirname `which gcc`)
 GCC_SUFFIX =
 CC ?= $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
@@ -94,10 +95,10 @@
 
 #default is to use Intel TBB
 ifneq (1,$(NO_TBB))
-	LIBS = $(PTHREAD_LIB) -ltbb -ltbbmalloc_proxy
+	LIBS += $(PTHREAD_LIB) -ltbb -ltbbmalloc_proxy
 	override EXTRA_FLAGS += -DWITH_TBB
 else
-	LIBS = $(PTHREAD_LIB)
+	LIBS += $(PTHREAD_LIB)
 endif
 SEARCH_LIBS =
 BUILD_LIBS =

=== debian/changelog ===
bowtie2 (2.3.2-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * Added RRID (SCR_005476)
  * Added OMICtools ref (OMIC_00653)

  [ matuskalas ]
  * Added bio.tools ref and removed whole URLs (@smoe decision)

  [ Alexandre Mestiashvili ]
  * Bump Standards-Version to 4.0.0
  * Hardcode binary package name instead of using dpkg-parsechangelog
  * Upload to unstable

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 27 Jul 2017 15:30:16 +0200

bowtie2 (2.3.2-1) experimental; urgency=medium

  * New upstream version 2.3.2
  * Drop libreadline-dev build dependency
  * Refresh patches

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Wed, 24 May 2017 10:33:13 +0200

bowtie2 (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Refresh patches
  * Add zlib1g-dev and libreadline-dev build dependencies

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Tue, 07 Mar 2017 11:10:09 +0100

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,9 @@
                python,
                liblocal-lib-perl,
                libtest-deep-perl,
-               libclone-perl
-Standards-Version: 3.9.8
+               libclone-perl,
+               zlib1g-dev
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
+pkg := bowtie2
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

## bowtie2 2.3.4.1

=== Makefile ===
#
# Copyright 2011, Ben Langmead <langmea@cs.jhu.edu>
#
# This file is part of Bowtie 2.
#
# Bowtie 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Bowtie 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Bowtie 2.  If not, see <http://www.gnu.org/licenses/>.
#

#
# Makefile for bowtie, bowtie2-build, bowtie2-inspect
#

prefix := /usr/local
bindir := $(prefix)/bin

LDLIBS := -lz
GCC_PREFIX := $(shell dirname `which gcc`)
GCC_SUFFIX :=
CC ?= $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
CPP ?= $(GCC_PREFIX)/g++$(GCC_SUFFIX)
CXX ?= $(CPP)
CXXFLAGS += -std=c++98

HEADERS := $(wildcard *.h)
BOWTIE_MM := 1
BOWTIE_SHARED_MEM :=

ifdef RELEASE_BUILD
	LDFLAGS += -L$(CURDIR)/.lib
	CPPFLAGS += -I$(CURDIR)/.include
endif

# Detect Cygwin or MinGW
WINDOWS :=
MINGW :=
ifneq (,$(findstring MINGW,$(shell uname)))
	WINDOWS := 1
	MINGW := 1
	# POSIX memory-mapped files not currently supported on Windows
	BOWTIE_MM :=
	BOWTIE_SHARED_MEM :=
endif

MACOS :=
ifneq (,$(findstring Darwin,$(shell uname)))
	MACOS := 1
	ifeq (1,$(shell uname -r | awk -F. '{ if ($$1 > 12 && $$1 < 16) print 1; }'))
		CXXFLAGS += -stdlib=libstdc++
	endif
	ifdef RELEASE_BUILD
		CXXFLAGS += -mmacosx-version-min=10.9
	endif
endif

POPCNT_CAPABILITY ?= 1
ifeq (1, $(POPCNT_CAPABILITY))
    CXXFLAGS += -DPOPCNT_CAPABILITY
    CPPFLAGS += -I third_party
endif

MM_DEF :=

ifeq (1,$(BOWTIE_MM))
	MM_DEF := -DBOWTIE_MM
endif

SHMEM_DEF :=

ifdef BOWTIE_SHARED_MEM
	SHMEM_DEF := -DBOWTIE_SHARED_MEM
endif

PTHREAD_PKG :=
PTHREAD_LIB :=

#if we're not using TBB, then we can't use queuing locks
ifeq (1,$(NO_TBB))
	NO_QUEUELOCK := 1
endif

ifeq (1,$(MINGW))
	PTHREAD_LIB :=
else
	PTHREAD_LIB := -lpthread
endif

ifeq (1,$(NO_SPINLOCK))
	CXXFLAGS += -DNO_SPINLOCK
endif

#default is to use Intel TBB
ifneq (1,$(NO_TBB))
	LDLIBS += $(PTHREAD_LIB) -ltbb
	ifdef RELEASE_BUILD
		LDLIBS += -ltbbmalloc
	else
		LDLIBS += -ltbbmalloc_proxy
	endif
	CXXFLAGS += -DWITH_TBB
else
	LDLIBS += $(PTHREAD_LIB)
endif

ifeq (1,$(WITH_THREAD_PROFILING))
	CXXFLAGS += -DPER_THREAD_TIMING=1
endif

ifeq (1,$(WITH_AFFINITY))
	CXXFLAGS += -DWITH_AFFINITY=1
endif

#default is to use Intel TBB's queuing lock for better thread scaling performance
ifneq (1,$(NO_QUEUELOCK))
	CXXFLAGS += -DNO_SPINLOCK
	CXXFLAGS += -DWITH_QUEUELOCK=1
endif

SHARED_CPPS := ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
               edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
               reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
			   random_source.cpp

ifeq (1,$(NO_TBB))
	SHARED_CPPS += tinythread.cpp
endif

SEARCH_CPPS := qual.cpp pat.cpp sam.cpp \
               read_qseq.cpp aligner_seed_policy.cpp \
               aligner_seed.cpp \
			   aligner_seed2.cpp \
			   aligner_sw.cpp \
			   aligner_sw_driver.cpp aligner_cache.cpp \
			   aligner_result.cpp ref_coord.cpp mask.cpp \
			   pe.cpp aln_sink.cpp dp_framer.cpp \
			   scoring.cpp presets.cpp unique.cpp \
			   simple_func.cpp \
			   random_util.cpp \
			   aligner_bt.cpp sse_util.cpp \
			   aligner_swsse.cpp outq.cpp \
			   aligner_swsse_loc_i16.cpp \
			   aligner_swsse_ee_i16.cpp \
			   aligner_swsse_loc_u8.cpp \
			   aligner_swsse_ee_u8.cpp \
			   aligner_driver.cpp

SEARCH_CPPS_MAIN := $(SEARCH_CPPS) bowtie_main.cpp

DP_CPPS := qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
          simple_func.cpp sse_util.cpp aligner_bt.cpp aligner_swsse.cpp \
		  aligner_swsse_loc_i16.cpp aligner_swsse_ee_i16.cpp \
		  aligner_swsse_loc_u8.cpp aligner_swsse_ee_u8.cpp scoring.cpp

BUILD_CPPS := diff_sample.cpp
BUILD_CPPS_MAIN := $(BUILD_CPPS) bowtie_build_main.cpp

SEARCH_FRAGMENTS := $(wildcard search_*_phase*.c)
VERSION := $(shell cat VERSION)

BITS := 32
ifeq (x86_64,$(shell uname -m))
	BITS := 64
endif
ifeq (amd64,$(shell uname -m))
	BITS := 64
endif
# msys will always be 32 bit so look at the cpu arch instead.
ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
	ifeq (1,$(MINGW))
		BITS := 64
	endif
endif
ifeq (32,$(BITS))
  $(error bowtie2 compilation requires a 64-bit platform )
endif

SSE_FLAG := -msse2

DEBUG_FLAGS    := -O0 -g3 -m64 $(SSE_FLAG)
RELEASE_FLAGS  := -O3 -m64 $(SSE_FLAG) -funroll-loops -g3
NOASSERT_FLAGS := -DNDEBUG
FILE_FLAGS     := -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(CXXFLAGS)\""
RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(CXXFLAGS)\""

ifeq (0,$(shell $(CPP) -E -fsanitize=address,undefined btypes.h 2>&1 > /dev/null; echo $$?))
	SANITIZER_FLAGS := -fsanitize=address,undefined
endif
ifndef SANITIZER_FLAGS
	ifeq (0,$(shell $(CPP) -E -fsanitize=address btypes.h 2>&1 > /dev/null; echo $$?))
		SANITIZER_FLAGS := -fsanitize=address
	endif
endif
ifndef SANITIZER_FLAGS
	ifeq (0,$(shell $(CPP) -E -fsanitize=undefined btypes.h 2>&1 > /dev/null; echo $$?))
		SANITIZER_FLAGS := -fsanitize=undefined
	endif
endif

BOWTIE2_BIN_LIST :=     bowtie2-build-s \
                        bowtie2-build-l \
                        bowtie2-align-s \
                        bowtie2-align-l \
                        bowtie2-inspect-s \
                        bowtie2-inspect-l
BOWTIE2_BIN_LIST_DBG := bowtie2-build-s-debug \
                        bowtie2-build-l-debug \
                        bowtie2-align-s-debug \
                        bowtie2-align-l-debug \
                        bowtie2-inspect-s-debug \
                        bowtie2-inspect-l-debug
BOWTIE2_BIN_LIST_SAN := bowtie2-build-s-sanitized \
                        bowtie2-build-l-sanitized \
                        bowtie2-align-s-sanitized \
                        bowtie2-align-l-sanitized \
                        bowtie2-inspect-s-sanitized \
                        bowtie2-inspect-l-sanitized

GENERAL_LIST := $(wildcard scripts/*.sh) \
                $(wildcard scripts/*.pl) \
                doc/manual.html \
                doc/README \
                doc/style.css \
			    $(wildcard example/index/*.bt2) \
			    $(wildcard example/reads/*.fq) \
			    $(wildcard example/reads/*.pl) \
			    example/reference/lambda_virus.fa \
                $(PTHREAD_PKG) \
			    bowtie2 \
			    bowtie2-build \
			    bowtie2-inspect \
                AUTHORS \
                LICENSE \
                NEWS \
                MANUAL \
                MANUAL.markdown \
                TUTORIAL \
                VERSION

ifeq (1,$(WINDOWS))
	BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
    ifneq (1,$(NO_TBB))
	    CXXFLAGS += -static-libgcc -static-libstdc++
	else
	    CXXFLAGS += -static -static-libgcc -static-libstdc++
	endif
endif

# This is helpful on Windows under MinGW/MSYS, where Make might go for
# the Windows FIND tool instead.
FIND := $(shell which find)

SRC_PKG_LIST = $(wildcard *.h) \
               $(wildcard *.hh) \
               $(wildcard *.c) \
               $(wildcard *.cpp) \
               $(wildcard third_party/*) \
               Makefile \
               $(GENERAL_LIST)

ifeq (1,$(WINDOWS))
	BIN_PKG_LIST := $(GENERAL_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
else
	BIN_PKG_LIST := $(GENERAL_LIST)
endif

.PHONY: all allall both both-debug

all: $(BOWTIE2_BIN_LIST) ;
allall: $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_DBG) $(BOWTIE2_BIN_LIST_SAN) ;
both: bowtie2-align-s bowtie2-build-s bowtie2-align-l bowtie2-build-l ;
both-debug: bowtie2-align-s-debug bowtie2-build-s-debug bowtie2-align-l-debug bowtie2-build-l-debug ;
both-sanitized: bowtie2-align-s-sanitized bowtie2-build-s-sanitized bowtie2-align-l-sanitized bowtie2-build-l-sanitized ;

DEFS := -fno-strict-aliasing \
        -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
        -DBUILD_HOST="\"`hostname`\"" \
        -DBUILD_TIME="\"`date`\"" \
        -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
        $(FILE_FLAGS) \
        $(PREF_DEF) \
        $(MM_DEF) \
        $(SHMEM_DEF)

# set compiler flags for all sanitized builds
$(BOWTIE2_BIN_LIST_SAN): CXXFLAGS += $(SANITIZER_FLAGS)

#
# bowtie2-build targets
#

bowtie2-build-s-sanitized bowtie2-build-s: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-l-sanitized bowtie2-build-l: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-s-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-l-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-align targets
#

bowtie2-align-s-sanitized bowtie2-align-s: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-l-sanitized bowtie2-align-l: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-s-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-l-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-inspect targets
#

bowtie2-inspect-s-sanitized bowtie2-inspect-s: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-inspect-l-sanitized bowtie2-inspect-l: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-inspect-l-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-dp targets
#

bowtie2-dp: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)

=== debian/changelog ===
bowtie2 (2.3.4.1-1) unstable; urgency=medium

  * New upstream version 2.3.4.1
  * Refresh d/patches/reproducible.patch
  * Check DEB_BUILD_PROFILES against nocheck, strip trailing white spaces

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Wed, 07 Feb 2018 23:23:01 +0100

bowtie2 (2.3.4-1) unstable; urgency=medium

  * New upstream version 2.3.4
  * Refresh patches
  * Update d/rules, add sanitized binaries for tests
  * Update d/bowties2.docs
  * Use /usr/share/dpkg/architecture.mk to find DEB_HOST_ARCH
  * Bump Standards-Version: to 4.1.3, debhelper and compatibility level to 11

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Sat, 06 Jan 2018 15:45:55 +0100

bowtie2 (2.3.3.1-1) unstable; urgency=medium

  * Update Files-Excluded list in d/copyright
  * Bump Standards-Version to 4.1.1
  * New upstream version 2.3.3.1
  * Refresh patches
  * Don't run random-test at all as it depends on non-free Math::Random package
  * Drop single-cpu-for-test.patch, as we disabled random-test target completely
  * Remove unnecessary testsuite line from d/control

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 13 Oct 2017 15:14:20 +0200

bowtie2 (2.3.3-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * debian/upstream/metadata: Corrected syntax
  * debian/control: policy bump to 4.0.1

  [ Alexandre Mestiashvili ]
  * Update Files-Excluded section in d/copyright
  * New upstream version 2.3.3
  * Bump Standards-Version in d/control
  * Refresh patches

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Mon, 11 Sep 2017 12:50:49 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,8 @@
 Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
            Andreas Tille <tille@debian.org>
 Section: science
-Testsuite: autopkgtest
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                help2man,
                libtbb-dev,
                python,
@@ -13,7 +12,7 @@
                libtest-deep-perl,
                libclone-perl,
                zlib1g-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,8 @@
 export LANG=C
 export LC_ALL=C.UTF-8
 
-DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+include /usr/share/dpkg/architecture.mk
+
 EXTRA_OPTIONS =
 ifneq ($(DEB_HOST_ARCH),amd64)
         EXTRA_OPTIONS = NO_TBB=1
@@ -21,14 +22,20 @@
 	dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	$(MAKE) EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) \
 	  bowtie2-build-s-debug \
 	  bowtie2-build-l-debug \
 	  bowtie2-align-s-debug \
 	  bowtie2-align-l-debug \
 	  bowtie2-inspect-s-debug \
-	  bowtie2-inspect-l-debug
+	  bowtie2-inspect-l-debug \
+	  bowtie2-align-s-sanitized \
+	  bowtie2-align-l-sanitized \
+	  bowtie2-build-s-sanitized \
+	  bowtie2-build-l-sanitized
 	make -j1 test
+endif
 
 override_dh_auto_install:
 	dh_auto_install
